Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 803371 - =sys-devel/gcc-11.1.0-r2 fails to cross compile into rootfs
Summary: =sys-devel/gcc-11.1.0-r2 fails to cross compile into rootfs
Status: UNCONFIRMED
Alias: None
Product: Gentoo Linux
Classification: Unclassified
Component: Current packages (show other bugs)
Hardware: All Linux
: Normal normal (vote)
Assignee: Gentoo Toolchain Maintainers
URL:
Whiteboard:
Keywords:
Depends on:
Blocks: gcc-11
  Show dependency tree
 
Reported: 2021-07-22 11:12 UTC by tt_1
Modified: 2021-10-09 16:35 UTC (History)
0 users

See Also:
Package list:
Runtime testing required: ---


Attachments
compressed build log (gcc-11.1.0-r2-build.log.gz,169.77 KB, application/gzip)
2021-07-22 11:12 UTC, tt_1
Details
output from emerge --info (host) (emerge-info,5.12 KB, text/plain)
2021-07-22 11:14 UTC, tt_1
Details
output from emerge --info (cross-target) (emerge-info-target,4.50 KB, text/plain)
2021-07-22 11:14 UTC, tt_1
Details
bootstrap order (rootfs-bootstrap,15.75 KB, text/plain)
2021-07-22 12:00 UTC, tt_1
Details
[PATCH] sys-devel/gcc: regression: fenv_t not declared (0001-sys-devel-gcc-regression-fenv_t-not-declared.patch,2.31 KB, patch)
2021-09-27 08:51 UTC, Nikita Shubin
Details | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description tt_1 2021-07-22 11:12:30 UTC
Created attachment 725785 [details]
compressed build log

reproducer:

get fresh stage3, update world, then emerge =sys-devel/gcc-11.1.0-r2. Eselect gcc-11 when done and do an emerge -e world for good measurement. 

next, emerge layman  and =sys-devel/crossdev-20210718 ; set up the cross compiler via: crossdev -S aarch64-unknown-linux-gnu --gcc 11.1.0-r2 --ov-output /var/lib/layman/crossdev/

when done, fix make.profile within /usr/aarch64-unknown-linux-gnu/etc/portage to /usr/portage/profiles/default/linux/arm64/17.0/ , and fixup the targets make.conf to only accept stable keywords. Also set USE="-rsync-verify -sanitize -installkernel" globally via make.conf

unmask =sys-devel/gcc-11.1.0-r2 for the target

populate the rootfs at /usr/aarch64-unknown-linux-gnu/ via emerge-aarch64-unknown-linux-gnu -auvND world and wait a bit, it will fail at =sys-devel/gcc-11.1.0-r2 with this beauty: 


/usr/aarch64-unknown-linux-gnu/tmp/portage/sys-devel/gcc-11.1.0-r2/work/build/aarch64-unknown-linux-gnu/libstdc++-v3/include/fenv.h:58:11: error: ‘fenv_t’ has not been declared in ‘::’
/usr/aarch64-unknown-linux-gnu/tmp/portage/sys-devel/gcc-11.1.0-r2/work/build/aarch64-unknown-linux-gnu/libstdc++-v3/include/fenv.h:59:11: error: ‘fexcept_t’ has not been declared in ‘::’
/usr/aarch64-unknown-linux-gnu/tmp/portage/sys-devel/gcc-11.1.0-r2/work/build/aarch64-unknown-linux-gnu/libstdc++-v3/include/fenv.h:62:11: error: ‘feclearexcept’ has not been declared in ‘::’
/usr/aarch64-unknown-linux-gnu/tmp/portage/sys-devel/gcc-11.1.0-r2/work/build/aarch64-unknown-linux-gnu/libstdc++-v3/include/fenv.h:63:11: error: ‘fegetexceptflag’ has not been declared in ‘::’
/usr/aarch64-unknown-linux-gnu/tmp/portage/sys-devel/gcc-11.1.0-r2/work/build/aarch64-unknown-linux-gnu/libstdc++-v3/include/fenv.h:64:11: error: ‘feraiseexcept’ has not been declared in ‘::’
/usr/aarch64-unknown-linux-gnu/tmp/portage/sys-devel/gcc-11.1.0-r2/work/build/aarch64-unknown-linux-gnu/libstdc++-v3/include/fenv.h:65:11: error: ‘fesetexceptflag’ has not been declared in ‘::’
/usr/aarch64-unknown-linux-gnu/tmp/portage/sys-devel/gcc-11.1.0-r2/work/build/aarch64-unknown-linux-gnu/libstdc++-v3/include/fenv.h:66:11: error: ‘fetestexcept’ has not been declared in ‘::’
/usr/aarch64-unknown-linux-gnu/tmp/portage/sys-devel/gcc-11.1.0-r2/work/build/aarch64-unknown-linux-gnu/libstdc++-v3/include/fenv.h:68:11: error: ‘fegetround’ has not been declared in ‘::’
/usr/aarch64-unknown-linux-gnu/tmp/portage/sys-devel/gcc-11.1.0-r2/work/build/aarch64-unknown-linux-gnu/libstdc++-v3/include/fenv.h:69:11: error: ‘fesetround’ has not been declared in ‘::’
/usr/aarch64-unknown-linux-gnu/tmp/portage/sys-devel/gcc-11.1.0-r2/work/build/aarch64-unknown-linux-gnu/libstdc++-v3/include/fenv.h:71:11: error: ‘fegetenv’ has not been declared in ‘::’
/usr/aarch64-unknown-linux-gnu/tmp/portage/sys-devel/gcc-11.1.0-r2/work/build/aarch64-unknown-linux-gnu/libstdc++-v3/include/fenv.h:72:11: error: ‘feholdexcept’ has not been declared in ‘::’
/usr/aarch64-unknown-linux-gnu/tmp/portage/sys-devel/gcc-11.1.0-r2/work/build/aarch64-unknown-linux-gnu/libstdc++-v3/include/fenv.h:73:11: error: ‘fesetenv’ has not been declared in ‘::’
/usr/aarch64-unknown-linux-gnu/tmp/portage/sys-devel/gcc-11.1.0-r2/work/build/aarch64-unknown-linux-gnu/libstdc++-v3/include/fenv.h:74:11: error: ‘feupdateenv’ has not been declared in ‘::’
/usr/aarch64-unknown-linux-gnu/tmp/portage/sys-devel/gcc-11.1.0-r2/work/build/aarch64-unknown-linux-gnu/libstdc++-v3/include/cfenv:61:11: error: ‘fenv_t’ has not been declared in ‘::’
/usr/aarch64-unknown-linux-gnu/tmp/portage/sys-devel/gcc-11.1.0-r2/work/build/aarch64-unknown-linux-gnu/libstdc++-v3/include/cfenv:62:11: error: ‘fexcept_t’ has not been declared in ‘::’
/usr/aarch64-unknown-linux-gnu/tmp/portage/sys-devel/gcc-11.1.0-r2/work/build/aarch64-unknown-linux-gnu/libstdc++-v3/include/cfenv:65:11: error: ‘feclearexcept’ has not been declared in ‘::’
/usr/aarch64-unknown-linux-gnu/tmp/portage/sys-devel/gcc-11.1.0-r2/work/build/aarch64-unknown-linux-gnu/libstdc++-v3/include/cfenv:66:11: error: ‘fegetexceptflag’ has not been declared in ‘::’
/usr/aarch64-unknown-linux-gnu/tmp/portage/sys-devel/gcc-11.1.0-r2/work/build/aarch64-unknown-linux-gnu/libstdc++-v3/include/cfenv:67:11: error: ‘feraiseexcept’ has not been declared in ‘::’
/usr/aarch64-unknown-linux-gnu/tmp/portage/sys-devel/gcc-11.1.0-r2/work/build/aarch64-unknown-linux-gnu/libstdc++-v3/include/cfenv:68:11: error: ‘fesetexceptflag’ has not been declared in ‘::’
/usr/aarch64-unknown-linux-gnu/tmp/portage/sys-devel/gcc-11.1.0-r2/work/build/aarch64-unknown-linux-gnu/libstdc++-v3/include/cfenv:69:11: error: ‘fetestexcept’ has not been declared in ‘::’
/usr/aarch64-unknown-linux-gnu/tmp/portage/sys-devel/gcc-11.1.0-r2/work/build/aarch64-unknown-linux-gnu/libstdc++-v3/include/cfenv:71:11: error: ‘fegetround’ has not been declared in ‘::’
/usr/aarch64-unknown-linux-gnu/tmp/portage/sys-devel/gcc-11.1.0-r2/work/build/aarch64-unknown-linux-gnu/libstdc++-v3/include/cfenv:72:11: error: ‘fesetround’ has not been declared in ‘::’
/usr/aarch64-unknown-linux-gnu/tmp/portage/sys-devel/gcc-11.1.0-r2/work/build/aarch64-unknown-linux-gnu/libstdc++-v3/include/cfenv:74:11: error: ‘fegetenv’ has not been declared in ‘::’
/usr/aarch64-unknown-linux-gnu/tmp/portage/sys-devel/gcc-11.1.0-r2/work/build/aarch64-unknown-linux-gnu/libstdc++-v3/include/cfenv:75:11: error: ‘feholdexcept’ has not been declared in ‘::’
/usr/aarch64-unknown-linux-gnu/tmp/portage/sys-devel/gcc-11.1.0-r2/work/build/aarch64-unknown-linux-gnu/libstdc++-v3/include/cfenv:76:11: error: ‘fesetenv’ has not been declared in ‘::’
/usr/aarch64-unknown-linux-gnu/tmp/portage/sys-devel/gcc-11.1.0-r2/work/build/aarch64-unknown-linux-gnu/libstdc++-v3/include/cfenv:77:11: error: ‘feupdateenv’ has not been declared in ‘::’
/usr/aarch64-unknown-linux-gnu/tmp/portage/sys-devel/gcc-11.1.0-r2/work/build/aarch64-unknown-linux-gnu/libstdc++-v3/include/fenv.h:58:11: error: ‘fenv_t’ has not been declared in ‘::’
/usr/aarch64-unknown-linux-gnu/tmp/portage/sys-devel/gcc-11.1.0-r2/work/build/aarch64-unknown-linux-gnu/libstdc++-v3/include/fenv.h:59:11: error: ‘fexcept_t’ has not been declared in ‘::’
/usr/aarch64-unknown-linux-gnu/tmp/portage/sys-devel/gcc-11.1.0-r2/work/build/aarch64-unknown-linux-gnu/libstdc++-v3/include/fenv.h:62:11: error: ‘feclearexcept’ has not been declared in ‘::’
/usr/aarch64-unknown-linux-gnu/tmp/portage/sys-devel/gcc-11.1.0-r2/work/build/aarch64-unknown-linux-gnu/libstdc++-v3/include/fenv.h:63:11: error: ‘fegetexceptflag’ has not been declared in ‘::’
/usr/aarch64-unknown-linux-gnu/tmp/portage/sys-devel/gcc-11.1.0-r2/work/build/aarch64-unknown-linux-gnu/libstdc++-v3/include/fenv.h:64:11: error: ‘feraiseexcept’ has not been declared in ‘::’
/usr/aarch64-unknown-linux-gnu/tmp/portage/sys-devel/gcc-11.1.0-r2/work/build/aarch64-unknown-linux-gnu/libstdc++-v3/include/fenv.h:65:11: error: ‘fesetexceptflag’ has not been declared in ‘::’
/usr/aarch64-unknown-linux-gnu/tmp/portage/sys-devel/gcc-11.1.0-r2/work/build/aarch64-unknown-linux-gnu/libstdc++-v3/include/fenv.h:66:11: error: ‘fetestexcept’ has not been declared in ‘::’
/usr/aarch64-unknown-linux-gnu/tmp/portage/sys-devel/gcc-11.1.0-r2/work/build/aarch64-unknown-linux-gnu/libstdc++-v3/include/fenv.h:68:11: error: ‘fegetround’ has not been declared in ‘::’
/usr/aarch64-unknown-linux-gnu/tmp/portage/sys-devel/gcc-11.1.0-r2/work/build/aarch64-unknown-linux-gnu/libstdc++-v3/include/fenv.h:69:11: error: ‘fesetround’ has not been declared in ‘::’
/usr/aarch64-unknown-linux-gnu/tmp/portage/sys-devel/gcc-11.1.0-r2/work/build/aarch64-unknown-linux-gnu/libstdc++-v3/include/fenv.h:71:11: error: ‘fegetenv’ has not been declared in ‘::’
/usr/aarch64-unknown-linux-gnu/tmp/portage/sys-devel/gcc-11.1.0-r2/work/build/aarch64-unknown-linux-gnu/libstdc++-v3/include/fenv.h:72:11: error: ‘feholdexcept’ has not been declared in ‘::’
/usr/aarch64-unknown-linux-gnu/tmp/portage/sys-devel/gcc-11.1.0-r2/work/build/aarch64-unknown-linux-gnu/libstdc++-v3/include/fenv.h:73:11: error: ‘fesetenv’ has not been declared in ‘::’
/usr/aarch64-unknown-linux-gnu/tmp/portage/sys-devel/gcc-11.1.0-r2/work/build/aarch64-unknown-linux-gnu/libstdc++-v3/include/fenv.h:74:11: error: ‘feupdateenv’ has not been declared in ‘::’
/usr/aarch64-unknown-linux-gnu/tmp/portage/sys-devel/gcc-11.1.0-r2/work/build/aarch64-unknown-linux-gnu/libstdc++-v3/include/cfenv:61:11: error: ‘fenv_t’ has not been declared in ‘::’
/usr/aarch64-unknown-linux-gnu/tmp/portage/sys-devel/gcc-11.1.0-r2/work/build/aarch64-unknown-linux-gnu/libstdc++-v3/include/cfenv:62:11: error: ‘fexcept_t’ has not been declared in ‘::’
/usr/aarch64-unknown-linux-gnu/tmp/portage/sys-devel/gcc-11.1.0-r2/work/build/aarch64-unknown-linux-gnu/libstdc++-v3/include/cfenv:65:11: error: ‘feclearexcept’ has not been declared in ‘::’
/usr/aarch64-unknown-linux-gnu/tmp/portage/sys-devel/gcc-11.1.0-r2/work/build/aarch64-unknown-linux-gnu/libstdc++-v3/include/cfenv:66:11: error: ‘fegetexceptflag’ has not been declared in ‘::’
/usr/aarch64-unknown-linux-gnu/tmp/portage/sys-devel/gcc-11.1.0-r2/work/build/aarch64-unknown-linux-gnu/libstdc++-v3/include/cfenv:67:11: error: ‘feraiseexcept’ has not been declared in ‘::’
/usr/aarch64-unknown-linux-gnu/tmp/portage/sys-devel/gcc-11.1.0-r2/work/build/aarch64-unknown-linux-gnu/libstdc++-v3/include/cfenv:68:11: error: ‘fesetexceptflag’ has not been declared in ‘::’
/usr/aarch64-unknown-linux-gnu/tmp/portage/sys-devel/gcc-11.1.0-r2/work/build/aarch64-unknown-linux-gnu/libstdc++-v3/include/cfenv:69:11: error: ‘fetestexcept’ has not been declared in ‘::’
/usr/aarch64-unknown-linux-gnu/tmp/portage/sys-devel/gcc-11.1.0-r2/work/build/aarch64-unknown-linux-gnu/libstdc++-v3/include/cfenv:71:11: error: ‘fegetround’ has not been declared in ‘::’
/usr/aarch64-unknown-linux-gnu/tmp/portage/sys-devel/gcc-11.1.0-r2/work/build/aarch64-unknown-linux-gnu/libstdc++-v3/include/cfenv:72:11: error: ‘fesetround’ has not been declared in ‘::’
/usr/aarch64-unknown-linux-gnu/tmp/portage/sys-devel/gcc-11.1.0-r2/work/build/aarch64-unknown-linux-gnu/libstdc++-v3/include/cfenv:74:11: error: ‘fegetenv’ has not been declared in ‘::’
/usr/aarch64-unknown-linux-gnu/tmp/portage/sys-devel/gcc-11.1.0-r2/work/build/aarch64-unknown-linux-gnu/libstdc++-v3/include/cfenv:75:11: error: ‘feholdexcept’ has not been declared in ‘::’
/usr/aarch64-unknown-linux-gnu/tmp/portage/sys-devel/gcc-11.1.0-r2/work/build/aarch64-unknown-linux-gnu/libstdc++-v3/include/cfenv:76:11: error: ‘fesetenv’ has not been declared in ‘::’
/usr/aarch64-unknown-linux-gnu/tmp/portage/sys-devel/gcc-11.1.0-r2/work/build/aarch64-unknown-linux-gnu/libstdc++-v3/include/cfenv:77:11: error: ‘feupdateenv’ has not been declared in ‘::’


here are the useflags for the hosts system-gcc:

Calculating dependencies... done!
[ebuild   R   ~] sys-devel/gcc-11.1.0-r2:11::gentoo  USE="(cxx) fortran (multilib) nls nptl openmp pch (pie) sanitize ssp (-ada) -custom-cflags -d -debug -doc (-fixed-point) -go -graphite (-hardened) -jit (-libssp) -lto -objc -objc++ -objc-gc -pgo -systemtap -test -valgrind -vanilla -vtv -zstd" 0 KiB

here are the useflags for the hosts cross-gcc:

emerge -pv cross-aarch64-unknown-linux-gnu/gcc

These are the packages that would be merged, in order:

Calculating dependencies... done!
[ebuild   R   ~] cross-aarch64-unknown-linux-gnu/gcc-11.1.0-r2:11::crossdev  USE="cxx fortran nls nptl openmp pch pie ssp -ada -custom-cflags -d -debug -doc (-fixed-point) -go -graphite -hardened -jit -libssp -lto -multilib -objc -objc++ -objc-gc -pgo -sanitize -systemtap -test -valgrind -vanilla -vtv -zstd" 0 KiB


here are the useflag for the targets sys-devel/gcc
emerge-aarch64-unknown-linux-gnu -pv gcc

These are the packages that would be merged, in order:

Calculating dependencies... done!
[ebuild  N    ~] sys-devel/gcc-11.1.0-r2:11::gentoo to /usr/aarch64-unknown-linux-gnu/ USE="(cxx) fortran nls nptl openmp pch (pie) ssp (-ada) -custom-cflags -d -debug -doc (-fixed-point) -go -graphite (-hardened) -jit (-libssp) -lto (-multilib) -objc -objc++ -objc-gc -pgo -sanitize -systemtap -test (-valgrind) -vanilla -vtv -zstd" 0 KiB



I'm quite puzzled by the amount of missing declared errors, also I have no idea where this may be coming from.
Comment 1 tt_1 2021-07-22 11:14:28 UTC
Created attachment 725788 [details]
output from emerge --info (host)
Comment 2 tt_1 2021-07-22 11:14:42 UTC
Created attachment 725791 [details]
output from emerge --info (cross-target)
Comment 3 tt_1 2021-07-22 12:00:02 UTC
Created attachment 725794 [details]
bootstrap order

attached you will find the output of emerge-aarch64-unknown-linux-gnu -auvND world, this command bootstraps the rootfs and shows the order of emerged packages. The list will fail when =sys-devel/gcc-11.1.0-r2 is reached.
Comment 4 tt_1 2021-07-29 17:26:25 UTC
I will retry with =sys-devel/gcc-11.2.0
Comment 5 tt_1 2021-09-18 20:38:55 UTC
thanks for the heads up, do you know which of the two patches in the upstream bug are worth a try?
Comment 6 Nikita Shubin 2021-09-27 08:51:27 UTC
Created attachment 741654 [details, diff]
[PATCH] sys-devel/gcc: regression: fenv_t not declared

Same for sys-devel/gcc-11.2.0

Had luck with the following patch.